from matplotlib.pyplot import *
from numpy import *
from random import random

old_name = "histogram_RL.dat"      # The name of input histogram file
new_name = "histogram_RL_new.dat"  # The name of output histogram file

N_burst = 5         # number of photons in single burst

bins = 100 #number of new histogram bins (it is good to use the same value as in the old histogram data)


AVhist = loadtxt(old_name)
NEW_hist = zeros((bins,4)) 

# The burst function calculate the new histogram of data, combining data into bursts of N photons
#  Use:  new_histogram = burst( photons number in a burst , old_histogram, column number with x values, 
#                                    column number with y values  )

def burst(N,DATA,x,y): 

  steps = 50000 #number of new histogram data points
  new_histogram = zeros((bins,2))

  new_histogram[:,0] = DATA[:,x]
  vmin = DATA[0,x]
  vmax = DATA[-1,x]
  DATA[:,y] /= sum(DATA[:,y])
  
  for st in range(steps):
    V = 0.0
    sum_photon = 0.0
    for n in range(N):
      suma = 0.0
      v = 0.0
      rn = random()
      i = 0                                 
      while rn > suma:
        suma += DATA[i,y] 
        v = DATA[i,x]
        i+= 1

      sum_photon += v
    V = sum_photon/float(N)
    index = int((V - vmin)/((vmax-vmin)/float(bins)))
    new_histogram[index-1,1] += 1
  
  return new_histogram


  
# Distance distribution
  
AV = burst(N_burst,AVhist,0,1)
NEW_hist[:,0] = AV[:,0]
NEW_hist[:,1] = AV[:,1]


figure()

plot(AV[:,0],AV[:,1]/(sum(AV[:,1])*(AV[1,0]-AV[0,0])))

xlabel('dye to dye distance')
ylabel('Probability')


# Efficiency distribution
  
AV = burst(N_burst,AVhist,2,3)
NEW_hist[:,2] = AV[:,0]
NEW_hist[:,3] = AV[:,1]


figure()

plot(AV[:,0],AV[:,1]/(sum(AV[:,1])*(AV[1,0]-AV[0,0])))

xlabel('FRET efficiency')
ylabel('Probability')

savetxt(new_name,NEW_hist)

show()